import math
'''Path'''

execfile('Qscan.211215.py')
this_file_path = sys._getframe().f_code.co_filename

datapath=r'C:\Users\Majorana\Desktop\qtlab\data\2022-02-10_Center_InSb-Tin_QPC4_BominVictor_cooldown1'
filename='datC%s'%strftime('%y%m')#C: center, S: side

'''Measurement setup'''
# Manually update the following details as a note.
device1 = {
    'chip': '20220221 Sn QPC4',
    'device': '2.61',
    'source': {'p4-p2': (5,36),# pins
        'in': (2, '0.5 kHz', 'no lockin'),# slot position, filter, ISO in
        'module': ('S4m','100 nA/V','V2=-V4'),# !!! change elsewhere: labels in e.scan
        },
    'measure': {'p4-p2': (5,36),# pins
        'out': (2, '0.1 kHz', '100 kHz + keithley1, no lockin'),# slot position, filter, ISO out
        'module': ('M2b', '1 kV/V', '1 kV/V'),# !!! change elsewhere: labels channels_to_read. First is dc amp, second is ac amp
        },
    'gates': (),# !!! change elsewhere: labels in e.scan. 
}

delay1 = 1.0#delay in seconds after setting z, y, and x[0] (before an x-channel scan). Lockin: 10*tau, DC: 1
delay2 = 0.05#delay in seconds before taking data. >=1.5*tau for lockins, default 0.1

channels_to_read = [('keithley1','readnextval','e-3V')]#,('lockin2','R','e-3V')]#]#,('magnetX','Bx'),('magnetY','By')]#,('fridge','T_MC (K)'),('[xy]lockin1','1e-6A')]##, #,('Lakeshore','T(K)')]#[(a1,b1),(a2,b2),...],a is an instrument whose readings will be taken, b is a description for the reading.
colx = 1#col number for x axis. Used if is_print_cmd = True, first index is 1
coly = 4#col number for y axis. Used if is_print_cmd = True, first index is 1

# Redefine the set function
#def new_set_val(self,chan,val):
#    if self.is_dac_name(chan):
#        return ivvi.set(chan,val)
#    elif chan == 'magnet' or chan == 'magnetX':
#        return qt.instruments.get(chan).set_field(val)
#    elif chan == 'MC_SetPoint':
#        qt.instruments.get('fridge').set_I_list([0,0,0,val])
#        # if you need to wait for the stabilization
#        margin_relative = 3e-3
#        k = 0
#        tmc = qt.instruments.get('fridge').get_MC()
#        while 1:
#            if abs(tmc*1000.-val)<abs(val*margin_relative):
#                k += 1
#            else:
#                k = 0
#            if k == 2:
#                return True
#            else:
#                qt.msleep(60)
#                tmc = qt.instruments.get('fridge').get_MC()
#    return False
#get_set.set_val = new_set_val

#If using vector magnet change theta degrees here!


R = 0.25
MAX_R = 0.95

#2D
#THETA = 32

#Parallel
#THETA3D = 170 
#PHI3D = 120

#Perpendicular
#THETA3D = 80 
#PHI3D = 120
def get_field_fast(chan,val=None):
    instr = qt.instruments.get(chan)
    para = instr.get_parameters()['field']
    b = para['value']
    if b is None:
        b = instr.get('field')
    return b

def get_setpoint2(self,chan,val):
        '''set values of an output channel, keep update with get_val and get_rate!
        def set_magnet_3D(r,theta,phi):
            t_rad = theta/180.*math.pi
            p_rad = phi/180.*math.pi
            bx = r*math.sin(t_rad)*math.cos(p_rad)
            by = r*math.cos(t_rad)*math.sin(p_rad)
            bz = r*math.cos(r_rad)'''
        ''' In coordinates related to Wires, as wire is (r,theta,phi) in spherical coordinates,
            Let Wires direction as Bz", and it is in plane Bx"-Bz", if in plane perpendicular to wire:
            Bx = Bx"cos(phi)cos(theta) - By"sin(phi) + Bz"sin(theta)cos(phi)
            By = Bx"sin(phi)cos(theta) + By"cos(phi) + Bz"sin(theta)sin(phi)
            Bz = -Bx"sin(theta) + Bz"cos(theta)
            This scan starts from in plane Bx" = Br.'''

        def set_B_safely(x,y):
            x0 = get_field_fast('magnetX')
            y0 = get_field_fast('magnetY')
            t = MAX_R*MAX_R
            if (x*x+y*y<t and x0*x0+y0*y0<t
                and x*x+y0*y0<t and x0*x0+y*y<t):
                return [['magnetX','field',x],['magnetY','field',y]]
            else:
                print '\nError, vector out of maximum total value'
                sys.exit()
                
        def set_B_safely3D(x,y,z):
            x0 = get_field_fast('magnetX')
            y0 = get_field_fast('magnetY')
            z0 = get_field_fast('magnet')
            t = MAX_R*MAX_R
            if (x*x+y*y+z*z<t and x0*x0+y0*y0+z0*z0<t and x*x+y0*y0+z*z<t and x0*x0+y*y+z*z and x*x+y*y+z0*z0<t and x0*x0+y0*y0+z*z<t and x0*x0+y*y+z0*z0<t and x*x+y0*y0+z0*z0<t):
                return [['magnetX','field',x],['magnetY','field',y],['magnet','field',z]]
            else:
                print '\nError, vector out of maximum total value'
                sys.exit()
                
        if self.is_dac_name(chan):
            return [['ivvi',chan,val],]
        elif chan == 'magnet' or chan == 'magnetX' or chan == 'magnetY':
            return [[chan,'field',val],]
        elif chan == 'magnetR':
            t_rad = THETA/180.*math.pi
            x = val*math.cos(t_rad)
            y = val*math.sin(t_rad)
            return set_B_safely(x,y)
        elif chan == 'magnetTheta':
            t_rad = val/180.*math.pi
            x = R*math.cos(t_rad)
            y = R*math.sin(t_rad)
            return set_B_safely(x,y)
        elif chan == 'magnetR3D':
            t_rad = THETA3D/180.*math.pi
            p_rad = PHI3D/180.*math.pi
            x = val*math.sin(t_rad)*math.cos(p_rad)
            y = val*math.sin(t_rad)*math.sin(p_rad)
            z = val*math.cos(t_rad)
            return set_B_safely3D(x,y,z)
        elif chan == 'magnetTheta3D':
            t_rad = val/180.*math.pi
            p_rad = PHI3D/180.*math.pi
            x = R3D*math.sin(t_rad)*math.cos(p_rad)
            y = R3D*math.sin(t_rad)*math.sin(p_rad)
            z = R3D*math.cos(t_rad)
            return set_B_safely3D(x,y,z)
        elif chan == 'magnetPhi3D':
            t_rad = THETA3D/180.*math.pi
            p_rad = val/180.*math.pi
            x = R3D*math.sin(t_rad)*math.cos(p_rad)
            y = R3D*math.sin(t_rad)*math.sin(p_rad)
            z = R3D*math.cos(t_rad)
            return set_B_safely3D(x,y,z)
        elif chan == 'magnetPerpendicular3D':
            a_rad = val/180.*math.pi
            t_rad = THETA3D/180.*math.pi
            p_rad = PHI3D/180.*math.pi
            Bx_new = R3D*math.cos(a_rad)
            By_new = R3D*math.sin(a_rad)
            x =  Bx_new*math.cos(p_rad)*math.cos(t_rad)-By_new*math.sin(p_rad)
            y =  Bx_new*math.sin(p_rad)*math.cos(t_rad)+By_new*math.cos(p_rad)
            z = -Bx_new*math.sin(t_rad)
            return set_B_safely3D(x,y,z) 
        elif chan == 'mw_power':
            return [['mw','power',val],]
        elif chan == 'mw_freq':
            return [['mw','frequency',val],]
        return None
 
 
get_set.get_setpoint = get_setpoint2

g = get_set()
''' if you need add processed data '''
g._prcss_labels += ['Bx(T)', 'By(T)', 'Bz(T)']
g._prcss_funs += [{'function':get_field_fast,'arg':'magnetX'},{'function':get_field_fast,'arg':'magnetY'},{'function':get_field_fast,'arg':'magnet'}]
e = easy_scan()

#MEASUREMENTS
# bwd=True: sweep back after each line; xswp_by_mchn=FALSE or TRUE: usually not used
###1d
#e.scan('Vbias(*10uV)','dac1',0,1000,100)
#e.scan('Vbias(*10uV)','dac1',300,-300,200)
#e.scan('Vbias(*10uV)','dac1',-300,0,100)
#e.scan('Ibias(*1nA)','dac2',200,-200,200)
#e.scan('Ibias(*0.1nA)','dac2',0,1000,200)
#e.scan('Ibias(*0.1nA)','dac2',2000,-2000,500)
#e.scan('Ibias(*1nA)','dac2',-300,300,200)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[100]*2,[-200]*2,100)
#e.scan('Ibias(*0.1nA)','dac2',2000,-2000,400)
#e.scan('Ibias(*1nA)','dac2',150,-150,200)
#e.scan('Ibias(*0.1nA), Iac = 1nA','dac2',400,-400,200)
#e.scan('Ibias(*1nA)','dac2',300,-300,300)

## 1 gate sweep
#e.scan('g1(*5mV)','dac11',-1000,-1200,200)
#e.scan('g2(*5mV)','dac12',0,-1000,100)
#e.scan('g2(*5mV)','dac12',-1000,1000,200)
#e.scan('g2(*5mV)','dac12',0,-22000,1000)
#e.scan('g2(*5mV)','dac12',500,-1000,500)
#e.set('dac2',5)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-200]*2,[-500]*2,200)
#e.scan('Ibias(*1nA)','dac2',-100,100,200)
#e.scan('Ibias(*1nA)','dac2',100,-100,200)
#e.scan('Ibias(*1nA)','dac2',300,-300,300,'field(T)','magnet',3.0,-0.2,160)#, bwd = True)
#e.set('magnet',0.42)
#e.set('ivvi',0)


## 2 gates sweep
#e.scan('Ibias(*0.1nA)','dac2',1000,-1000,400,['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[1000]*2,[500]*2,200)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[200]*2,[-200]*2,400)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-500]*2,[-100]*2,200)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-1000]*2,[-200]*2,100)
#e.scan('Vbias(*10uV)','dac1',200,-200,200,['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-600]*2,[-800]*2,100)
#e.scan('Vbias(*10uV), Vac = 50uV','dac1',1500,-1500,500,'g1(*5mV)','dac11',0,-2000,200)
#e.set('dac11',-1300)
#e.scan('Ibias(1nA)','dac2',300,-300,200,['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-1000]*2,[500]*2,300)
#e.set('dac12',-2000)
#e.scan('Vbias(*10uV)','dac1',200,-200,200,'g1(*5mV)','dac11',-1500,-2000,100)
#e.scan('g2(*5mV)','dac12',-1500,-2000,200,'g1(*5mV)','dac11',-1500,-2000,200)
#e.scan('Vbias(*10uV), Vac = 50uV','dac1',200,-200,200,'field(T)','magnet',-0.2,2,220)
#e.scan(['g1(*5mV)','g3(*5mV)'],['dac11','dac13'],[0]*2,[-1000]*2,100)
#e.scan('Ibias(*1nA)','dac2',200,-200,200)

## 3 gates sweep
e.scan(['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[100]*3,[200]*3,100)
#e.scan(['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[160]*3,[150]*3,100)
#e.scan('Ibias(*0.1nA)','dac2',2000,-2000,200,['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[0]*3,[300]*3,100)
#e.scan('Ibias(*1nA)','dac2',200,-200,200,['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[200]*3,[0]*3,100)
#e.scan(['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[-1000]*3,[500]*3,500)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[1000]*2,[0]*2,500)
#e.scan('Ibias(*0.1nA)','dac2',1500,-1500,200,'field(T)','magnetY',0,0.2,40)

#microwave
#e.set('magnet',0)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[500]*2,[1000]*2,200) 
#for i in [5.0e9]:
#    e.set('mw_freq',i)
#    qt.instruments.get('mw').set_power(-15)
#    qt.instruments.get('mw').set_status('on')
#    qt.msleep(10)
#    e.scan('Ibias(*1nA)','dac2',100,-100,200,'field(T)','magnet',1.0,1.5,100)#, bwd = True)
#    e.scan(['I1(*1nA)'],['dac2'],[100],[-100],200,['P(dBm)'],['mw_power'],[-15],[20],70)#[i[1]+10],200)
#    qt.instruments.get('mw').set_status('off')

#for i in [2e9]:
#    e.set('mw_freq',i)
#    qt.instruments.get('mw').set_power(-20)
#    qt.instruments.get('mw').set_status('on')
#    qt.msleep(10)
#    e.scan(['I1(*nA)'],['dac2'],[200],[-200],200,['P(dBm)'],['mw_power'],[-25],[15],120)#[i[1]+10],200)
#    qt.instruments.get('mw').set_status('off')
#e.set('ivvi',0)
    

'''map'''
#e.set('dac2',80)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[0]*2,[-500]*2,100)
#e.scan('Ibias(*1nA)','dac2',100,-100,200)
#e.scan('Ibias(*1nA)','dac2',-100,100,200)
#e.set('dac2',20)
#qt.instruments.get('mw').set_frequency(0.1e9)
#qt.instruments.get('mw').set_power(-35)
#qt.instruments.get('mw').set_status('on')
#e.scan(['f(Hz)'],['mw_freq'],[0.1e9],[10e9],100, ['P(dBm)'],['mw_power'],[-40],[20],120)
#qt.instruments.get('mw').set_status('off')
#e.set('ivvi',0)

#e.scan('Vbias(*10uV) Vac = 50uV','dac1',600,-300,300,'field(T)','magnet',2,0,200)
#e.scan('Ibias(*1nA)','dac2',100,-100,100,['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-1300]*2,[-1000]*2,100)#, bwd = True)
#e.set('ivvi',0)
#e.scan('field(T)','magnet',-0.5,0,50)
#e.scan('g1(*5mV)','dac11',0,-800,400,'field(T)','magnet',-0.3,5,212)


#XY Rotating
#e.scan('g1(*5mV)','dac11',-400,-200,100)
#e.scan('Ibias(*1nA)','dac2',500,-500,500)
#e.scan('Ibias(*1nA)','dac2',-200,200,400)
#e.scan('theta(degree)','magnetTheta',90,0,100)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,100,'theta(degree)','magnetTheta',32,0,32)
#e.scan('Ibias(*1nA)','dac2',200,-200,200,'field(T)','magnetX',-0.2,0.2,40)
#e.scan('Ibias(*1nA)','dac2',300,-300,200,'field(T)','magnetX',0.3,-0.3,60)
# e.scan(['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[200]*3,[150]*3,50)
#e.scan(['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[0]*3,[150]*3,100)
# R = 0.05
# e.scan('Ibias(*0.1nA)','dac2',1000,200,400,'theta(degree)','magnetTheta',0,360,180)
# e.scan('Ibias(*0.1nA)','dac2',-200,-1000,400,'theta(degree)','magnetTheta',0,360,180)
#e.scan('Ibias(*0.1nA)','dac2',-600,-1600,500,'theta(degree)','magnetTheta',0,360,360)
# R = 0.1
# e.scan('Ibias(*0.1nA)','dac2',100,-100,100,'theta(degree)','magnetTheta',0,360,100, bwd = True)
#e.scan('field(T)','magnetX',0,0.05,1)
#e.scan('g1(*5mV)','dac11',0,-200,200)
#e.scan('Ibias(*1nA)','dac2',300,-300,200,'g1(*5mV)','dac11',-600,600,200)

#XYZ 3D
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[200]*2,[400]*2,100)

#e.scan('Ibias(*0.1nA),Iac=0.5nA','dac2', 100,-100,200,'field(T)','magnetR3D',0.3,-0.3,60)
#e.scan('g1(*5mV)','dac11',0,1500,500)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',300,-300,200,'field(T)','magnetR3D',0.5,-0.5,100)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-800]*2,[-1600]*2,400)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-1600]*2,[-1500]*2,100)

#THETA3D = 0 
#PHI3D = 0
#e.scan('Ibias(*0.1nA)','dac2',2000,-2000,400,'alpha(degree)','magnetPerpendicular3D',0,720,360)
#e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',300,-300,150,'alpha(degree)','magnetPerpendicular3D',0,720,360)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,100,'theta(degree)','magnetTheta3D',140,190,25)
# R3D = 0.05
# PHI3D = 0
# e.scan('Ibias(*0.1nA)','dac2',2000,-2000,400,'Phi(degree)','magnetTheta3D',0,360,90)
# e.scan('Ibias(*0.1nA)','dac2',-200,-1000,400,'Phi(degree)','magnetTheta3D',0,360,180)
R3D = 0.05
PHI3D = 90
e.scan('Ibias(*0.1nA)','dac2',2000,-2000,400,'Phi(degree)','magnetTheta3D',0,360,90)
#e.scan('Ibias(*0.1nA)','dac2',-200,-1000,400,'Phi(degree)','magnetTheta3D',0,360,180)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',75,100,25)
#e.scan('field(T)','magnetR3D',0,0.9,90)
#e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',600,-600,300,'field(T)','magnetR3D',0.4,-0.4,160)

#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,200,'field(T)','magnetR3D',0.5,-0.5,100)
#e.set('ivvi',0)

#Scan on 10/27/2021
#Vg = -200
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[0]*2,[-200]*2,200)
#THETA3D = 90
#PHI3D = 80
#e.set('magnetR3D',0)
#2D map
#Tc measurement
#e.scan('T_set(K)','Lakeshore',10,5,200)
#e.scan('time1 (s)','time',0,100,50)
#t0 = time();e.scan('t (s)','time',time()-t0,time()-t0+3600*2,1,xswp_by_mchn=True)
#chns=range(1,17);e.scan(['g%d'%x for x in chns],['dac%d'%x for x in chns],[10 for x in chns],[0 for x in chns],50)
#while 1:
#    e.scan('Ibias(*1uA)','dac1',100,-100,200,'x','x',0,1,300,bwd=True)
#e.scan('Ibias(*1uA), Iac(0.5uA)','dac2',200,-200,400,'MC(mK)','MC_SetPoint',4000,1150,59,bwd=True)
#e.scan('Ibias(*0.01nA)','dac2',200,-200,400,'g1(*5mV)','dac10',0,1000,200)
#e.scan('MC(mK)','MC_SetPoint',1160,1150,10)
#e.set('MC_SetPoint',1170,1150,2)


#e.scan('time','time',0,3600,3600)


#e.scan('Ibias(*0.01nA)','dac1',400,-400,400,'g2','dac12',50,70,40)



#e.scan('Bg(*15mV)','dac3',287,200,200)
#e.scan('Ibias(*0.1nA)','dac1',300,-300,600,'Vbg(*15mV)','dac3',250,350,100)
#e.scan('field(T)','magnet',0.1,0.15,100)
#e.scan('Bg(*15mV)','dac3',350,180,200)
#e.scan('Ibias(*0.1nA)','dac1',300,-300,600,'Vbg(*15mV)','dac3',180,350,170)


#e.scan('Ibias(*0.01nA)','dac1',200,-200,500,'field(T)','magnet',-0.1,0.5,120)
#e.scan('time1 (s)','time',0,100,100,'time2 (s)','time',0,100,100)
###3d
#e.scan(['g1'],['dac1'],[0],[3],10,     ['g3'],['dac3'],[0],[3],10,     ['g5'],['dac5'],[0],[3],10)